import { ReactElement } from 'react';
import { Navigate, Outlet } from 'react-router-dom';
import { AuthType, WithHocAuth } from '../../hoc';

export const AuthRoute = ({
  auth,
  redirectUrl,
  children = null
}: {
  auth: AuthType;
  redirectUrl: string;
  children?: ReactElement | null;
}) => {
  return auth ?
    (children ? children : <Outlet />) :
    <Navigate to={redirectUrl} replace />;
};

export const AuthRouteWithHoc = WithHocAuth(AuthRoute);
